/* Installer -- Williams
   Its ugly to have all of this in one file, but it makes
   things simpler since this is a pared down version of
   CoolWorx that "thinks" it is in a DLL

   By making it one source file, the old globals can
   be static and not interfere with the user's namespace
   */
#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include <winver.h>
#include <stdlib.h>
#include <ctype.h>
#ifdef __BORLANDC__
#include <dir.h>
#else
#include <direct.h>
#endif
#include <dos.h>
#include <ddeml.h>
#include "cwinstal.h"

#ifdef COMCTL
#include <commctrl.h>
#endif

#ifdef _WIN32
#define _export
#endif

static HANDLE hInst;
static HWND mainw,prog;
static char srcdir[_MAX_PATH];
static HBITMAP logobm;
static ATOM aCW_MODELESSv;
static char cw_SdiClass[]="CWINSTALLWIN";
EXPORT LONG WINAPI self_subclass(HWND w,UINT message,
  WPARAM wParam, LPARAM lParam);


#define aCW_MODELESS MAKEINTATOM(aCW_MODELESSv)

long WINAPI _export win_proc(HWND hWnd, UINT message,
         UINT wParam, LONG lParam);
int init(HANDLE,HANDLE,int);


/* Start CoolWorks */
BOOL WINAPI  cw_Begin(HANDLE hInst)
  {
  return cw_BeginIcons(hInst,
    LoadIcon(NULL,IDI_APPLICATION));
  }


BOOL reg_classes(HANDLE hInst,HICON mdiicon)
        {
  WNDCLASS wc;
/* SDI window */
        wc.style=CS_HREDRAW|CS_VREDRAW;
        wc.lpfnWndProc=(WNDPROC)self_subclass;
        wc.cbClsExtra=0;
  wc.cbWndExtra=4;
        wc.hInstance=hInst;
  wc.hIcon=mdiicon;
        wc.hCursor=LoadCursor(NULL,IDC_ARROW);
  wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
  wc.lpszMenuName=NULL;
  wc.lpszClassName=cw_SdiClass;
  return RegisterClass(&wc);
  }

BOOL WINAPI  cw_BeginIcons(HANDLE hInst,
        HICON mdiicon)
  {
  WNDCLASS wc;
   InitCommonControls();
  if (!reg_classes(hInst,mdiicon)) return FALSE;
  return TRUE;
  }

/* General purpose message loop */
WORD WINAPI  cw_Run(HWND w,HWND mdi,int nracc,
  LPHANDLE ary,BOOL idle,BOOL help)
  {
  MSG msg;
  int i;
  while (1)
    {
    if (PeekMessage(&msg,NULL,0,0,PM_NOREMOVE))
      {
      if (!GetMessage(&msg,NULL,0,0)) break;
      TranslateMessage(&msg);
      DispatchMessage(&msg);
      }
    }
  return msg.wParam;
  }

HWND WINAPI  cw_SDICreate(LPCSTR title,LPCSTR menu,
   HANDLE hInst,
   FARPROC cb,LPCSTR top,LPCSTR left,LPCSTR right,LPCSTR bot,
   LONG lParam)
   {
   HWND w;
   w=CreateWindow(cw_SdiClass,title,
   WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_THICKFRAME|WS_MINIMIZEBOX,
     CW_USEDEFAULT,0,CW_USEDEFAULT,0,NULL,LoadMenu(hInst,menu),
     hInst,cb);
  if (w)
    SendMessage(w,CW_SDICREATE,0,0);
  return w;
  }

LONG WINAPI _export cw_DefWindowProc(HWND w,UINT msg,
  UINT wParam, LONG lParam)
  {
  switch (msg)
    {
    case WM_CLOSE:
      if (SendMessage(w,WM_QUERYENDSESSION,1,0))
        {
        DestroyWindow(w);
        }
      return 0;
    }
  return DefWindowProc(w,msg,wParam,lParam);
  }


/* Simple progress dialog */
BOOL WINAPI _export
cwProgDlg (HWND dlg, UINT msg, WPARAM wParam, LPARAM lParam)
  {
  if (msg == WM_INITDIALOG)
      {
      HWND sb=GetDlgItem(dlg,11);
      int parts[2];
      parts[0]=30;
      parts[1]=-1;
      SendMessage(sb,SB_SETPARTS,sizeof(parts)/sizeof(parts[0]),
        (DWORD)parts);
      }
  if (msg == WM_COMMAND && LOWORD(wParam) == IDCANCEL)
      {
      SendDlgItemMessage (dlg, 12, BM_SETCHECK, 1, 0);
      return TRUE;
      }
  return FALSE;
  }


HWND WINAPI
cw_ProgressDlg (HWND w, LPCSTR title, LPCSTR text,
      DWORD max, BOOL cancel)
  {
  HWND dlg;
  dlg = CreateDialog (hInst, "ProgDlg", w, cwProgDlg);
  if (dlg)
      {
      SendMessage (dlg, WM_SETTEXT, 0, (DWORD) title);
      SendDlgItemMessage (dlg, 11, WM_SETTEXT, 0, (DWORD) text);
      SendDlgItemMessage(dlg,10,PBM_SETRANGE,0,MAKELPARAM(0,max));
      if (!cancel)
      ShowWindow (GetDlgItem (dlg, IDCANCEL), SW_HIDE);
      ShowWindow (dlg, SW_SHOW);
      UpdateWindow (dlg);
      }
  return dlg;
  }

BOOL WINAPI
cw_ProgressCancel (HWND dlg)
  {
  return SendDlgItemMessage (dlg, 12, BM_GETCHECK, 0, 0);
  }

BOOL WINAPI
cw_ProgressSet (HWND dlg, DWORD amt,LPCSTR text)
  {
  MSG m;
  char num[10];
  if (!dlg) dlg=prog;
  SendDlgItemMessage(dlg,10,PBM_SETPOS,amt,0);
  if (amt!=0xFFFF)
    wsprintf(num,"%d",amt);
  else
    num[0]='\0';
  if (text)
    SendDlgItemMessage(dlg,11,SB_SETTEXT,1,(DWORD)text);
  SendDlgItemMessage(dlg,11,SB_SETTEXT,0,(DWORD)num);
  UpdateWindow (dlg);
  while (PeekMessage (&m, dlg, 0, 0, PM_REMOVE) ||
    PeekMessage (&m, GetDlgItem (dlg, IDCANCEL), 0, 0, PM_REMOVE))
      {
      if (!IsDialogMessage (dlg, &m))
        DispatchMessage (&m);
      }
  return cw_ProgressCancel (dlg);
  }

void WINAPI
cw_ProgressReset (HWND dlg)
  {
  SendDlgItemMessage (dlg, 12, BM_SETCHECK, 0, 0);
  }


LONG WINAPI _export self_subclass(HWND w,UINT message,
  WPARAM wParam, LPARAM lParam)
  {
  FARPROC p;
  if (message==WM_CREATE)
    {
    LPCREATESTRUCT cs=(LPCREATESTRUCT)lParam;
    SetWindowLong(w,0,(LONG)cs->lpCreateParams);
    }
  p=(FARPROC)GetWindowLong(w,0);
  return p?
    CallWindowProc(p,w,message,wParam,lParam):
    DefWindowProc(w,message,wParam,lParam);
  }


/* Select a logo that best fits the screen
   Arrange bitmaps so that the largest are first.

   In other words, if you had three logos,
   put a 1024x768 bitmap first,
   followed by an 800x600 bitmap, followed by a
   640x480 bitmap. This call will stop on the first one
   small enough to fit */
HBITMAP WINAPI cw_LogoBestBitmap(HANDLE hInst,UINT st,UINT end)
  {
  int xs,ys;
  UINT rc;
  HBITMAP tst=NULL,tst1=NULL;
  BITMAP binfo;
  xs=GetSystemMetrics(SM_CXSCREEN);
  ys=GetSystemMetrics(SM_CYSCREEN);
  for (rc=st;rc<=end;rc++)
    {
    tst1=LoadBitmap(hInst,MAKEINTRESOURCE(rc));
    if (tst1)
      {
      if (tst) DeleteObject(tst);
      tst=tst1;
      GetObject(tst,sizeof(BITMAP),&binfo);
      if (binfo.bmWidth<=xs&&binfo.bmHeight<=ys)
         return tst;
      }
    }
  return tst;
  }


/******** Install specific stuff here ********/
/* Copy file without compression */
BOOL copyfile(LPSTR dstdir,LPSTR dst,LPSTR srcdir,LPSTR src)
  {
  char fbuf[512],fn[_MAX_PATH];
  HFILE sh,dh;
#ifdef _WIN32
  FILETIME f1,f2,f3;
#endif
  int ct;
  unsigned attrib,dat,tim;
  lstrcpy(fn,srcdir);
  if (fn[lstrlen(fn)-1]!='\\') lstrcat(fn,"\\");
  lstrcat(fn,src);
  sh=_lopen(fn,OF_READ);
  if (sh==HFILE_ERROR) return FALSE;
#ifdef _WIN32
  attrib=GetFileAttributes(fn);
#else
  _dos_getfileattr(fn,&attrib);
#endif
  lstrcpy(fn,dstdir);
  if (fn[lstrlen(fn)-1]!='\\') lstrcat(fn,"\\");
  lstrcat(fn,dst);
  dh=_lcreat(fn,0);
  if (dh==HFILE_ERROR)
    {
    _lclose(sh);
    return FALSE;
    }
  do
    {
    int ct1;
    ct=_lread(sh,fbuf,sizeof(fbuf));
    if (ct==HFILE_ERROR) break;
    ct1=_lwrite(dh,fbuf,ct);
    if (ct1==HFILE_ERROR||ct1!=ct)
      ct=HFILE_ERROR;
    } while (ct!=HFILE_ERROR&&ct==sizeof(fbuf));
#ifdef _WIN32
  GetFileTime(sh,&f1,&f2,&f3);
  SetFileTime(dh,&f1,&f2,&f3);
#else
  _dos_getftime(sh,&dat,&tim);
  _dos_setftime(dh,dat,tim);
#endif
  _lclose(sh);
  if (_lclose(dh)==HFILE_ERROR) return FALSE;
#ifdef _WIN32
  SetFileAttributes(fn,attrib);
#else
  _dos_setfileattr(fn,attrib);
#endif
  return TRUE;
  }


/* Ver error messages */
char *vermessage[]=
  {
  "Unknown installation error on this file.",
  "The destination disk is write protected. Can't install.",
  "This file is in use.\nYou may need to close other applications.",
  "The disk is full.\nYou may need to install to a different drive.",
  "An access violation occurred.\nCheck for a write protected file.",
  "A sharing violation occurred.\nYou may need to close other applications.",
  "An error occured while creating this file.",
  "Out of memory! Try closing other applications.",
  "Can't find file on installation disk.\n"
     "Are you using original installation disks?"
  };

struct dlgboxparam
  {
  char *msg;
  char *srcdir;
  int sizsrc;
  };

/* Prompt for a new disk */
BOOL WINAPI diskdlg(HWND dlg,UINT cmd,WPARAM wParam, LPARAM lParam)
  {
  static struct dlgboxparam *pblk;
  switch (cmd)
    {
    case WM_INITDIALOG:
      {
      pblk=(struct dlgboxparam *)lParam;
      SendDlgItemMessage(dlg,PROMPT,WM_SETTEXT,0,(DWORD) pblk->msg);
      SendDlgItemMessage(dlg,SRCDIR,WM_SETTEXT,0,(DWORD) pblk->srcdir);
      SendDlgItemMessage(dlg,SRCDIR,EM_SETSEL,0,0x7FFF);
      return TRUE;
      }

    case WM_COMMAND:
      switch (LOWORD(wParam))
        {
        case IDOK:
          SendDlgItemMessage(dlg,SRCDIR,WM_GETTEXT,pblk->sizsrc,(DWORD)pblk->srcdir);
          EndDialog(dlg,0);
          return TRUE;
        case IDCANCEL:
          EndDialog(dlg,-1);
          return TRUE;
        }
    }
  return FALSE;
  }


/* The meat of the program */
int WINAPI cw_Install(HWND w,LPSTR appdir,DWORD bitmask,
   struct install_dirs *subdirs,int NRDIRS,
   struct _inst_files *inst_files,int NRFILES,unsigned long space,
   BOOL mbflag)
  {
  int i;
  unsigned cdlen;
  unsigned inslen;
  char tmpfile[_MAX_PATH];
  char curdir[_MAX_PATH];
  char instdir[_MAX_PATH];
  char srcf[_MAX_PATH];
  unsigned tmplen;
  if (i=cw_ChdirEx(appdir))
    {
    if (i==-2)
      {
      MessageBox(w,"Invalid drive.",NULL,MB_OK);
      return -2;
      }
    switch (
       MessageBox(w,"Directory does not exist. Create?"
         ,"Notice",MB_YESNOCANCEL))
       {
       case IDYES:
/* xmkdir takes care of some Win16 issues
   -- just maps to CreateDirectory under Win32 */
         if (xmkdir(appdir)||cw_ChdirEx(appdir))
           {
direrr:
           MessageBox(w,"Can't create directory.",
             NULL,MB_OK|MB_ICONSTOP);
           return -2;
           }
         break;

       case IDNO:
         return -2;
       case IDCANCEL:
         return -1;
       }
    } else
  switch (MessageBox(w,"Directory exists. Use anyway?",
    "Notice",MB_YESNOCANCEL))
    {
    case IDNO:
      return -2;
    case IDCANCEL:
      return -1;
    }
  UpdateWindow(w);
  if (space)
    {
    unsigned long freesp;
#ifdef _WIN32
    DWORD secper,bps,freec,tclust;
#else
    struct diskfree_t df;
#endif
/* Compute free space */
#ifdef _WIN32
    GetDiskFreeSpace(NULL,&secper,&bps,&freec,&tclust);
    freesp=(unsigned long)secper*bps*freec;
#else
    _dos_getdiskfree(0,&df);
    freesp=(unsigned long)df.avail_clusters*df.sectors_per_cluster*df.bytes_per_sector;
#endif
    if (freesp/1024<space)
      {
      int id=
        MessageBox(w,"You may not have enough free disk space.\n"
          "If you are reinstalling this program or use compressed disks\n"
          "you may be able to install.\n"
          "Press Yes to continue, No to select another drive.\n"
          "Press Cancel to terminate",NULL,MB_ICONSTOP|MB_YESNOCANCEL);
       if (id==IDNO) return -2;
       if (id==IDCANCEL) return -1;
       }
    }
/* Set up progress bar */
  if (!prog)
    prog=cw_ProgressDlg(w,"Installing...","",
      NRDIRS+NRFILES,TRUE);
  if (prog) // position progress bar
    {
    RECT r,dr;
    int x,y,h,xw;
    GetClientRect(w,&r);
    ClientToScreen(w,(LPPOINT)&r);
    ClientToScreen(w,((LPPOINT)&r)+1);
    GetWindowRect(prog,&dr);
    x=((r.right-r.left)-(xw=dr.right-dr.left))/2;
    y=((r.bottom-r.top)-(h=dr.bottom-dr.top))/2;
    MoveWindow(prog,x+r.left,y+r.top,xw,h,TRUE);
    }
/* Need to make directory tree here */
  for (i=0;i<NRDIRS;i++)
    {
    if (subdirs[i].bitmask)
      if (!(subdirs[i].bitmask&bitmask)) continue;
    if (prog)
      {
      char ptitle[_MAX_PATH+33];
      wsprintf(ptitle,"Creating subdirectory %s",
        (LPSTR)subdirs[i].dir);
      if (cw_ProgressSet(prog,i,ptitle)) return -1;
      UpdateWindow(w);
      }
    if (access(subdirs[i].dir,0)&&mkdir(subdirs[i].dir))
      {
      MessageBox(w,"Can't create subdirectory.",
        subdirs[i].dir,MB_OK|MB_ICONSTOP);
      return -2;
      }
    }
/* Install files */
  for (i=0;i<NRFILES;i++)
    {
    UINT vrv;
    DWORD vrvi;
    char *dst;
/* Skip file if install bits don't match */
    if (inst_files[i].bitmask)
      if (!(inst_files[i].bitmask&bitmask)) continue;
    if (!inst_files[i].srcfile)
      {
      /* Special... prompt for new disk */
      static char msg[66],idfile[_MAX_PATH];
      if (srcdir[lstrlen(srcdir)-1]!='\\') lstrcat(srcdir,"\\");
      wsprintf(msg,"Please insert disk #%d",inst_files[i].flags);
      if (srcdir[lstrlen(srcdir)-1]=='\\')
        srcdir[lstrlen(srcdir)-1]='\0';
      wsprintf(idfile,"%s\\DISK%d.ID",(LPSTR)srcdir,
        inst_files[i].flags);

      while (access(idfile,0))
        {
        struct dlgboxparam pblk;
        pblk.msg=msg;
        pblk.srcdir=srcdir;
        pblk.sizsrc=sizeof(srcdir);
        if (DialogBoxParam(hInst,MAKEINTRESOURCE(DISKDLG),
          w,diskdlg,(DWORD)&pblk))
          return -1;
        UpdateWindow(w);
        if (srcdir[lstrlen(srcdir)-1]=='\\')
          srcdir[lstrlen(srcdir)-1]='\0';
        wsprintf(idfile,"%s\\DISK%d.ID",(LPSTR)srcdir,inst_files[i].flags);
        }
      continue;
      }
/* Get on with it */
    if (inst_files[i].dstfile)
      dst=inst_files[i].dstfile;
    else
      {
      dst=strrchr(inst_files[i].srcfile,'\\');
      if (dst) dst++; else dst=inst_files[i].srcfile;
      }
    if (prog)
      {
      char ptitle[_MAX_PATH+33];
      wsprintf(ptitle,"Installing %s",(LPSTR)dst);
      if (cw_ProgressSet(prog,i+NRDIRS,ptitle)) return -1;
      UpdateWindow(w);
      }
fretry:
    cdlen=sizeof(curdir);
    inslen=sizeof(instdir);
    if (inst_files[i].flags==0xFFFF)
      {
      /* copy unconditionally w/o decompress or checking */
      if (!copyfile(inst_files[i].dstdir,dst,
        srcdir,inst_files[i].srcfile))
        {
        int id=
          MessageBox(w,"Could not copy this file.\n"
           "You may be able to close other applications\n"
           "and then successfuly install.\n"
           "Retry?",inst_files[i].srcfile,
           MB_RETRYCANCEL|MB_ICONSTOP);
        if (id==IDRETRY) goto fretry;
        return -1;
        }
      }
    else
      {
      vrv=VerFindFile(inst_files[i].flags,dst,
        NULL,inst_files[i].dstdir?inst_files[i].dstdir:
          appdir,curdir,&cdlen,instdir,&inslen);
      if (vrv&VFF_FILEINUSE)
        {
        int id=
          MessageBox(w,"This file is in use and can't be"
          " installed.\n"
          "You may be able to close other applications\n"
          "and then successfuly install.\n"
          "Retry?",inst_files[i].srcfile,
           MB_RETRYCANCEL|MB_ICONSTOP);
        if (id==IDRETRY) goto fretry;
        return -1;
        }
      tmplen=sizeof(tmpfile);
      if (!lstrcmpi(curdir,srcdir)) *curdir='\0';
      if ((vrv&VFF_CURNEDEST)&&*curdir
        &&!(inst_files[i].flags&VFFF_ISSHAREDFILE))
          *curdir='\0';
      if (inst_files[i].dstdir)
        {
        if (inst_files[i].dstdir==(char *)1)
          getboot(instdir);  /* not supported for WIN32 */
        else if (inst_files[i].dstdir==(char *)2)
          GetWindowsDirectory(instdir,sizeof(instdir));
        else
          lstrcpy(instdir,inst_files[i].dstdir);
        }
      *tmpfile='\0';
      lstrcpy(srcf,srcdir);
      if (srcf[lstrlen(srcf)-1]!='\\') lstrcat(srcf,"\\");
      lstrcat(srcf,inst_files[i].srcfile);
      vrvi=VerInstallFile(inst_files[i].cflags,srcf,
         dst,"",
         instdir,
         curdir,tmpfile,&tmplen);
      if (vrvi&VIF_TEMPFILE)
        {
        char dfile[_MAX_PATH];
        lstrcpy(dfile,instdir);
        if (dfile[lstrlen(dfile)-1]!='\\')
          lstrcat(dfile,"\\");
        lstrcat(dfile,tmpfile);
        unlink(dfile);
        }
      if (vrvi&(VIF_WRITEPROT|VIF_FILEINUSE|
         VIF_OUTOFSPACE|VIF_ACCESSVIOLATION|
         VIF_SHARINGVIOLATION|VIF_CANNOTCREATE|
         VIF_CANNOTDELETE|VIF_CANNOTRENAME|
         VIF_OUTOFMEMORY|VIF_CANNOTREADSRC|
         VIF_CANNOTREADDST))
           {
           int m=0;
           int id;
           if (vrvi&VIF_WRITEPROT) m=1;
           if (vrvi&VIF_FILEINUSE) m=2;
           if (vrvi&VIF_OUTOFSPACE) m=3;
           if (vrvi&VIF_ACCESSVIOLATION) m=4;
           if (vrvi&VIF_SHARINGVIOLATION) m=5;
           if (vrvi&VIF_CANNOTCREATE) m=6;
           if (vrvi&VIF_CANNOTDELETE) m=6;
           if (vrvi&VIF_CANNOTRENAME) m=6;
           if (vrvi&VIF_OUTOFMEMORY) m=7;
           if (vrvi&VIF_CANNOTREADSRC) m=8;
           if (vrvi&VIF_CANNOTREADDST) m=6;
           id=MessageBox(w,vermessage[m]
             ,inst_files[i].srcfile,MB_RETRYCANCEL|MB_ICONSTOP);
           if (id==IDRETRY) goto fretry;
           return -1;
           }
       }  /* end of else */
    }
  cw_ProgressSet(prog,0xFFFF,"Copying Complete");
  if (mbflag)
    MessageBox(w,"Installation complete",
      "Success",MB_OK|MB_ICONEXCLAMATION);
  return 0;
  }

int WINAPI cw_ChdirEx(char *path)
  {
#ifdef _WIN32
  return !SetCurrentDirectory(path);
#else
  while (isspace(*path)) path++;
  if (path[1]==':')
    {
    int dn;
    setdisk(dn=toupper(path[0])-'A');
    if(getdisk()!=dn) return -2;
    path+=2;
    }
  return chdir(path);
#endif
  }



/* Main entry point */
int PASCAL WinMain(HANDLE hInstance, HANDLE prev,
              LPSTR cmdline, int show)
  {
  HANDLE acc=NULL;
  char *p,*myfilename;
  hInst=hInstance;
  while (isspace(*cmdline)) cmdline++;
  if (prev&&(!*cmdline||!hdcopy))
    {
    MessageBox(NULL,"Please close Install before running another copy.",
      NULL,MB_OK|MB_ICONSTOP);
    return 0;
    }
/* Find our directory and set to current */
  GetModuleFileName(hInst,srcdir,sizeof(srcdir));
  if (hdcopy&&!*cmdline)
    {
    /* First time so copy */
    char tcmdline[_MAX_PATH*2];
    char *tmpdir=getenv("TMP"),*p=strrchr(srcdir,'\\');
    CreateDialog(hInst,"WAITDLG",NULL,NULL);
    if (!tmpdir) tmpdir=getenv("TEMP");
    if (!tmpdir) tmpdir="C:\\";
    *p='\0';
    if (!copyfile(tmpdir,p+1,srcdir,p+1))
      {
      MessageBox(NULL,"Install could not copy itself to your hard disk.\n"
      "Please make sure your TMP environment variable is set properly.",
      NULL,MB_OK|MB_ICONSTOP);
      return 0;
      }
    if (tmpdir[lstrlen(tmpdir)-1]!='\\') lstrcat(tmpdir,"\\");
    wsprintf(tcmdline,"%s%s %c:\\ %s%s",(LPSTR)tmpdir,(LPSTR)(p+1),srcdir[0],(LPSTR)tmpdir,(LPSTR)(p+1));
/* Run our clone */
    WinExec(tcmdline,SW_SHOW);
    return 0;
    }

  if (!hdcopy)
     {
     p=strrchr(srcdir,'\\');
     if (p) *(p+1)='\0';
    }
  else
    {
    lstrcpy(srcdir,cmdline);
    p=strchr(srcdir,' ');
    if (p)
      {
      *p='\0';
      myfilename=p+1;
      }
    else
      myfilename=NULL;
    }
/* Really install */
  chdir(srcdir);
  cw_BeginIcons(hInst,LoadIcon(hInst,MAKEINTRESOURCE(APPICON)));
  if (!cw_InstallInit(hInst,cmdline,show)) return FALSE;
  if (!init(hInst,prev,show)) return FALSE;
  /* Vanilla event loop */
  cw_Run(mainw,NULL,0,NULL,FALSE,FALSE);
  if (hdcopy&&myfilename)
    unlink(myfilename);
  return FALSE;
  }


/* Create window here */
int init(HANDLE hInstance, HANDLE prev,int nCmdShow)
         {
         HWND            hWnd;
         /* Create a main window */
         mainw=hWnd=cw_SDICreate(TITLE,
           NULL,
           hInst,(FARPROC)win_proc,
           NULL,NULL,NULL,NULL,0);

         if (!hWnd)
           return FALSE;

         return TRUE;
         }


logo(HWND w)
  {
  logobm=cw_LogoBestBitmap(hInst,9000,9099);
  if (logobm)
    {
    BITMAP dim;
    RECT r;
    int x,y;
    GetObject(logobm,sizeof(dim),&dim);
    r.top=r.left=0;
    r.right=dim.bmWidth;
    r.bottom=dim.bmHeight;
    AdjustWindowRect(&r,WS_OVERLAPPEDWINDOW,FALSE);
    x=(GetSystemMetrics(SM_CXSCREEN)-(r.right-r.left))/2;
    y=(GetSystemMetrics(SM_CYSCREEN)-(r.bottom-r.top))/2;
    MoveWindow(w,x,y,r.right-r.left,r.bottom-r.top,TRUE);
    }
  ShowWindow(w,SW_SHOW);
  UpdateWindow(w);
  }

/* Window procedure */
long WINAPI _export win_proc(HWND hWnd, UINT message,
         UINT wParam, LONG lParam)
         {
         switch (message)
                  {

                  case CW_SDICREATE:
                    PostMessage(hWnd,WM_USER,0,0);
                    break;

                  case WM_SYSCOMMAND:
                     if ((wParam&0xFFF0)==SC_SCREENSAVE) return 0;

                  case WM_PAINT:
                      {
                      HDC dc,mem;
                      PAINTSTRUCT ps;
                      HBITMAP oldbm;
                      RECT r;
                      dc=BeginPaint(hWnd,&ps);
                      if (logobm)
                        {
                        mem=CreateCompatibleDC(dc);
                        oldbm=SelectObject(mem,logobm);
                        GetClientRect(hWnd,&r);
                        BitBlt(dc,r.left,r.top,r.right-r.left,
                        r.bottom-r.top,mem,0,0,SRCCOPY);
                        SelectObject(mem,oldbm);
                        DeleteDC(mem);
                        }
                      EndPaint(hWnd,&ps);
                      }
                    break;

                  case WM_USER:
                    logo(hWnd);
                    install(hWnd,hInst,srcdir);
                    if (prog) DestroyWindow(prog);
                    DestroyWindow(hWnd);
                    break;

                  case WM_DESTROY:
                    if (logobm) DeleteObject(logobm);
                    logobm=NULL;
                    PostQuitMessage(0);
                    break;
                  }
/* Use CoolWorx default -- not windows! */
              return (cw_DefWindowProc(hWnd, message,
                         wParam, lParam));
         }

static BOOL vcomp(WORD v1,WORD v2)
  {
  if (HIBYTE(v1)<HIBYTE(v2)) return FALSE;
  if (HIBYTE(v1)>HIBYTE(v2)) return TRUE;
  return LOBYTE(v1)>=LOBYTE(v2);
  }

/* Check for minimum versions of DOS/Windows */
BOOL WINAPI cw_VersionCheck(WORD win,WORD dos)
  {
  DWORD vers=GetVersion();
  WORD rdos=HIWORD(vers),rwin=LOWORD(vers),tmp;
  rwin=((rwin&0xFF)<<8)|(rwin>>8);
  if (dos&&!vcomp(dos,rdos)) return FALSE;
  if (win&&!vcomp(win,rwin)) return FALSE;
  return TRUE;
  }

#ifndef _WIN32
static getboot(char *s)
  {
  union REGS r;
  r.x.ax=0x3305;
  int86(0x21,&r,&r);
  s[0]=r.h.dl+'A'-1;
  s[1]=':';
  s[2]='\\';
  }
#else
/* I don't know how to get the boot drive in Win32?? */
static getboot(char *s) { }
#endif

int xmkdir(char *dirs)
  {
#ifdef _WIN32
  return !CreateDirectory(dirs,NULL);
#else
  int offset=0,err=0;
  char *p,*sdir;
  if (dirs[1]==':')
    {
    offset=2;
    setdisk(toupper(dirs[0])-'A');
    }
  sdir=p=dirs+offset;
  if (*p=='\\') p++;
      while (p=strchr(p,'\\'))
        {
        *p='\0';
        if ((err=mkdir(sdir))==-1) break;
        *p='\\';
        p=sdir=p+1;
        }
      if (!err&&*sdir) err=mkdir(sdir);
      return err;
#endif
   }


/* DDEML Instance */
DWORD dde_inst=0;

/* Specific conversation */
HCONV conv;


static dde_start()
  {
  HSZ progman;
/* This starts us the first time or reinits on subsequent
   calls */
  DdeInitialize(&dde_inst,NULL,
       APPCLASS_STANDARD|APPCMD_CLIENTONLY,0);
  progman=DdeCreateStringHandle(dde_inst,
       "PROGMAN",CP_WINANSI);
  conv=DdeConnect(dde_inst,progman,progman,NULL);
  DdeFreeStringHandle(dde_inst,progman);
  return 0;
  }

/* End conversation */
static void dde_end()
  {
   DdeDisconnect(conv);
  }

static HDDEDATA dde_trans(void *data,
         HSZ hszItem, UINT wFmt,UINT wType,
         DWORD to,DWORD *res)
  {
  HDDEDATA rv=
    DdeClientTransaction(data,lstrlen(data)+1,conv,hszItem,wFmt,wType,
      to,res);
  return rv;
  }

BOOL WINAPI cw_ProgManCmd(char *s)
  {
  HDDEDATA rv;
  dde_start();
  rv=dde_trans(s,NULL,0,XTYP_EXECUTE,10000,NULL);
  dde_end();
  DdeUninitialize(dde_inst);
  dde_inst=0;
  return rv!=NULL;
  }


