#ifndef __CWINSTAL_H
#define __CWINSTAL_H
#include "cw.h"
#include <winver.h>

/* Your icon */
#define APPICON 555
/* Your 1st logo BMP -- use 9000-9099 */
#define FIRST_LOGO 9000

/* Used by internal resources */
#define DISKDLG 501
#define PROMPT 510
#define SRCDIR 102

/* Shorthand */
#define WINDIR NULL
#define SYSDIR ((char *)2)
#define RETRY -2
#define CANCEL -1
#define SUCCESS 0


#ifdef __cplusplus
extern "C" {
#endif

/* Subdirectory structure */
struct install_dirs
  {
  DWORD bitmask;
  char *dir;
  };

/* Files */
struct _inst_files
  {
  DWORD bitmask;
  char *srcfile;
  char *dstfile;
  char *dstdir;
  WORD flags;
  WORD cflags;
  };

/* Install helper functions */
/* change directory and disk */
int WINAPI cw_ChdirEx(char *path);
/* main install engine */
int WINAPI cw_Install(HWND w,LPSTR appdir,DWORD bitmask,
   struct install_dirs *subdirs,int nrdirs,
   struct _inst_files *inst_files,int nrfiles,unsigned long space,BOOL mbflag);
/* Verify DOS/Windows version #'s */
BOOL WINAPI cw_VersionCheck(WORD win,WORD dos);
/* Send program manager a command */
BOOL WINAPI cw_ProgManCmd(char *s);

/* You must provide this function */
int install(HWND w,HANDLE hInst,LPSTR srcdir);

/* You may provide this function */
BOOL WINAPI cw_InstallInit(HANDLE hInstance,
              LPSTR cmdline, int show);

/* Your title belongs in this global variable (you declare it) */
extern char TITLE[];
/* Set to TRUE for copy/run install (you declare it) */
extern BOOL hdcopy;

#ifdef __cplusplus
}
#endif

#endif
