#include "datagram.h"
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#define ERR_None				0L
#define ERR_MethodNotSupported 	421
#define ERR_ReadOnlyProperty 	20000	//should be 383 but I created 
										//my own text for the message
#define ERR_NOTCONNECTED		20001

#define HOST_NAME_LEN			50
#define WM_USER_ASYNC_SELECT	(WM_USER+201)

#define MAKEWORD(a, b)      	((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))

HANDLE 					hmodDLL;
WSADATA 				wsaData;
BOOL					initialized=FALSE;
WORD					VersionRequested=MAKEWORD(1,1);	//compatible with WinSock 1.1
unsigned int			MaxUDPBufferSize;
char					hostAddress[16];

int FAR PASCAL WEP(int);

int FAR PASCAL LibMain(hModule, wDataSeg, cbHeapSize, lpszCmdLine)
HANDLE  hModule;
WORD    wDataSeg;
WORD    cbHeapSize;
LPSTR   lpszCmdLine;
{
	hmodDLL = hModule;
    return 1;
}//LibMain

BOOL FAR PASCAL _export VBINITCC(USHORT usVersion,BOOL fRuntime)
{
	//this function is automatically called whenever an instance of the control
	//is loaded into memory
    char		hostName[HOST_NAME_LEN];
    PHOSTENT	phostent;
    IN_ADDR		in;

	//Run-Time-Only
	//uncomment the following lines to make a run-time only control
/*
	if (!fRuntime)
		return FALSE;
*/
	if (WSAStartup(VersionRequested,&wsaData)!=0) return FALSE; 
	//make sure that an appropriate version of WinSock is supported
	if ((LOBYTE(wsaData.wVersion)!=LOBYTE(VersionRequested))||
		(HIBYTE(wsaData.wVersion)!=HIBYTE(VersionRequested)))
	{
		WSACleanup();
		return FALSE;
	}
	if (!initialized)
	{
		//only need to get the host name one time
		gethostname(hostName,HOST_NAME_LEN);
		phostent=gethostbyname(hostName);
		memcpy(&in,phostent->h_addr,4);
		memcpy(hostAddress,inet_ntoa(in),16);
		//only need to get the max buffer size one time
		MaxUDPBufferSize=(unsigned int)wsaData.iMaxUdpDg;
		//the follwing is done because the calls to recv and sendto 
		//take an integer as their second parameter, not an unsigned int
		if (MaxUDPBufferSize>INT_MAX)
			MaxUDPBufferSize=INT_MAX;
		initialized=TRUE;
    }
    // Register control(s)
    return VBRegisterModel(hmodDLL, &modelDATAGRAM);
}//VBINITCC

int FAR PASCAL WEP(int nShutdownFlag)
{
	return 1;
}//End WEP

void FAR PASCAL _export VBTERMCC(void)
{          
	//this function is automatically called whenever an instance of the control
	//is unloaded from memory
	WSACleanup();
	return;
}//VBTERMCC

LONG FAR PASCAL _export DataGramCtlProc(HCTL hctl,HWND hwnd,USHORT msg,
    USHORT wp,LONG lp)
{
    HSZ				tempVBString;      
    LPSTR			lpstr=NULL;
    LPSTR			destAddr=NULL;
    char			fromAddr[16];
    char 			*tempIn;
   	SOCKADDR_IN		addr;
   	int 			addrLen=sizeof(addr);
   	int 			fromPort;
   	unsigned int	nBytesSent,nBytesRecv;
   	unsigned int	stringLen;
   	EVENT_PARAMS	params;
   	IN_ADDR			inFrom;

    switch (msg)
	{
	case WM_NCCREATE:          
		//default the properties
		DATAGRAMDEREF(hctl)->mToPort=0;
		tempVBString=VBCreateHsz((_segment)hctl,(LPSTR)hostAddress);
        DATAGRAMDEREF(hctl)->mMyAddress=tempVBString;
        DATAGRAMDEREF(hctl)->mMyPort=0;
		DATAGRAMDEREF(hctl)->mMaxBufferSize=(long int)MaxUDPBufferSize;
        DATAGRAMDEREF(hctl)->mErrorCode=0;                    
        DATAGRAMDEREF(hctl)->mSend=FALSE;
        DATAGRAMDEREF(hctl)->mConnected=FALSE;
        DATAGRAMDEREF(hctl)->mDisconnected=TRUE;
        DATAGRAMDEREF(hctl)->mappsocket=INVALID_SOCKET;
		break;
	case WM_NCDESTROY:
		//free string memory allocated with VBCreateHsz
		if (DATAGRAMDEREF(hctl)->mMyAddress)
		{
			VBDestroyHsz(DATAGRAMDEREF(hctl)->mMyAddress);
			DATAGRAMDEREF(hctl)->mMyAddress=NULL;
		}                              
		//close any opened socket
		if (DATAGRAMDEREF(hctl)->mappsocket!=INVALID_SOCKET)
		{
			if (closesocket(DATAGRAMDEREF(hctl)->mappsocket)==SOCKET_ERROR)
				DATAGRAMDEREF(hctl)->mErrorCode=WSAGetLastError();
			DATAGRAMDEREF(hctl)->mappsocket=INVALID_SOCKET;
		}   
		break;        
	case VBM_METHOD:
	    //there are no methods supported
	    return VBSetErrorMessage(ERR_MethodNotSupported,
	     "Method not applicable for this object.");
	case WM_USER_ASYNC_SELECT:
		if (WSAGETSELECTERROR(lp)!=0)
			return ERR_None;
		switch(WSAGETSELECTEVENT(lp))
		{
			case FD_READ:
				if (!DATAGRAMDEREF(hctl)->mSend)
				{
				 	tempIn=(char *)calloc(MaxUDPBufferSize,sizeof(char));
					//read the data
					nBytesRecv=recvfrom(DATAGRAMDEREF(hctl)->mappsocket,
						tempIn,MaxUDPBufferSize,0,(LPSOCKADDR)&addr,&addrLen);
					if (nBytesRecv==SOCKET_ERROR)
		        		DATAGRAMDEREF(hctl)->mErrorCode=WSAGetLastError();
		        	else
		        	{
						//get the from address
						memcpy(&inFrom,&addr.sin_addr.s_addr,4);
						memcpy(fromAddr,inet_ntoa(inFrom),16);
						//get the from port
						fromPort=ntohs(addr.sin_port);
						//set the event parameters
						params.FromPort=&fromPort;
						params.FromAddr = VBCreateHlstr(fromAddr, lstrlen(fromAddr));
						params.FromData = VBCreateHlstr(tempIn, lstrlen(tempIn));
						//fire the event
						VBFireEvent(hctl,IEVENT_DATAGRAM_DATAIN,&params);
						//free string memory allocated with VBCreateHlstr
						VBDestroyHlstr(params.FromData);
						VBDestroyHlstr(params.FromAddr);
					}            
					if (tempIn)
						free(tempIn);
				}
				break;
			case FD_WRITE:
				//has there been a notification to send data
	        	if (DATAGRAMDEREF(hctl)->mSend)
	        	{
		        	//get the destination port
		        	addr.sin_family=AF_INET;
		        	addr.sin_port=htons(DATAGRAMDEREF(hctl)->mToPort);
		        	//get the destination address
		        	destAddr=VBLockHsz(DATAGRAMDEREF(hctl)->mToAddress);
		        	addr.sin_addr.s_addr=inet_addr(destAddr);
		        	VBUnlockHsz(DATAGRAMDEREF(hctl)->mToAddress);
		        	if (DATAGRAMDEREF(hctl)->mToData)
		        	{                                     
		        		lpstr=VBLockHsz(DATAGRAMDEREF(hctl)->mToData);
		        		stringLen=lstrlen(lpstr);
		        		//send the data
		        		nBytesSent=sendto(DATAGRAMDEREF(hctl)->mappsocket,
		        			lpstr,stringLen,0,(LPSOCKADDR)&addr,sizeof(addr));	
		        		if (nBytesSent==SOCKET_ERROR)
		        			DATAGRAMDEREF(hctl)->mErrorCode=WSAGetLastError();
		        		//unlock it 
		        		VBUnlockHsz(DATAGRAMDEREF(hctl)->mToData);
		        	}   
		        	//reset the send flag
		        	DATAGRAMDEREF(hctl)->mSend=FALSE;
	        	}
				break;
			default:
				break;
        }
		return ERR_None;
	case VBM_SETPROPERTY:
        //called whenever a property is set
        switch(wp)
        {
        case IPROP_DATAGRAM_TOADDRESS:
		    return ERR_None;
        case IPROP_DATAGRAM_TOPORT:
		    return ERR_None;
        case IPROP_DATAGRAM_TODATA:
		    return ERR_None;
        case IPROP_DATAGRAM_MYADDRESS:
		    //read-only
			//clear it out
			if (DATAGRAMDEREF(hctl)->mMyAddress)
				VBDestroyHsz(DATAGRAMDEREF(hctl)->mMyAddress);
			//then set it to what the default is
			tempVBString=VBCreateHsz((_segment)hctl,(LPSTR)hostAddress);
	        DATAGRAMDEREF(hctl)->mMyAddress=tempVBString;
		    return VBSetErrorMessage(ERR_ReadOnlyProperty,
		     "Property is read-only.");
        case IPROP_DATAGRAM_MYPORT:
		    return ERR_None;
        case IPROP_DATAGRAM_MAXBUFFERSIZE:
		    //read-only
	    	DATAGRAMDEREF(hctl)->mMaxBufferSize=(long int)MaxUDPBufferSize;
	    	return VBSetErrorMessage(ERR_ReadOnlyProperty,
	     		"Property is read-only.");
        case IPROP_DATAGRAM_ERRORCODE:
		    return ERR_None;
        case IPROP_DATAGRAM_SEND:
			if (VBGetMode()==MODE_DESIGN)      
				//cannot set this property at design-time
				DATAGRAMDEREF(hctl)->mSend=FALSE;
			else
			    //place a FD_WRITE message in the application message que
			    PostMessage(hwnd,WM_USER_ASYNC_SELECT,DATAGRAMDEREF(hctl)->mappsocket,
			    	WSAMAKESELECTREPLY(FD_WRITE,0));
		    return ERR_None;
        case IPROP_DATAGRAM_CONNECTED:
			if (VBGetMode()==MODE_DESIGN)      
				//cannot set this property as design-time
				DATAGRAMDEREF(hctl)->mConnected=FALSE;
			else
			{
				if (DATAGRAMDEREF(hctl)->mConnected)
				{
					addr.sin_family=AF_INET;
					addr.sin_port=htons(DATAGRAMDEREF(hctl)->mMyPort);
					addr.sin_addr.s_addr=htonl(INADDR_ANY);				
					DATAGRAMDEREF(hctl)->mappsocket=socket(AF_INET,SOCK_DGRAM,0);			    
					if (DATAGRAMDEREF(hctl)->mappsocket==INVALID_SOCKET)
						DATAGRAMDEREF(hctl)->mErrorCode=WSAGetLastError();				
					else
					{
						if (bind(DATAGRAMDEREF(hctl)->mappsocket,
							(LPSOCKADDR)&addr,sizeof(addr))==SOCKET_ERROR)
							DATAGRAMDEREF(hctl)->mErrorCode=WSAGetLastError();
						else
						{
							//find out the port number that may have been
							//automatically assigned if myPort was 0
							getsockname(DATAGRAMDEREF(hctl)->mappsocket,
								(LPSOCKADDR)&addr,&addrLen);
							DATAGRAMDEREF(hctl)->mMyPort=ntohs(addr.sin_port);						
							//setup the asynchronous read/write handler
							if (WSAAsyncSelect(DATAGRAMDEREF(hctl)->mappsocket,
								hwnd,WM_USER_ASYNC_SELECT,FD_READ|FD_WRITE)==SOCKET_ERROR)
								DATAGRAMDEREF(hctl)->mErrorCode=WSAGetLastError();
						}
					    //set disconnected to false
					    DATAGRAMDEREF(hctl)->mDisconnected=FALSE;
				   	}
			    }
			    else
			    	//cannot toggle to false
			    	DATAGRAMDEREF(hctl)->mConnected=TRUE;
		    }
		    return ERR_None;
        case IPROP_DATAGRAM_DISCONNECTED:
			if (VBGetMode()==MODE_DESIGN)      
				//cannot set this property as design-time
				DATAGRAMDEREF(hctl)->mDisconnected=TRUE;
			else
			{
				if (DATAGRAMDEREF(hctl)->mDisconnected)
				{
					//close any opened socket
					if (DATAGRAMDEREF(hctl)->mappsocket!=INVALID_SOCKET)
					{
						if (closesocket(DATAGRAMDEREF(hctl)->mappsocket)==SOCKET_ERROR)
							DATAGRAMDEREF(hctl)->mErrorCode=WSAGetLastError();
						DATAGRAMDEREF(hctl)->mappsocket=INVALID_SOCKET;
					}   
				    //set connected to false
				    DATAGRAMDEREF(hctl)->mConnected=FALSE;
			    }           
			    else
			    	//cannot toggle to false
					DATAGRAMDEREF(hctl)->mDisconnected=TRUE;
			}
		    return ERR_None;
		default:
			break;       
        }
        break;
	}
    return VBDefControlProc(hctl, hwnd, msg, wp, lp);
}//DataGramCtlProc
