// DEFS.H (MOUSE.EXE)
// (C) 1994 Ahpah Software Inc.
// Description: Global typedefs and macros

/* global enumerations */
enum BOOLEAN { NO, YES };     // boolean yes or no type

/* generic integer types */
typedef int SIGNINT;          // general signed int type
typedef short SHORT;          // general short int type
typedef long LONG;            // general long type
typedef unsigned int WORD;    // appropriate for file writes and reads
typedef unsigned int INDEX;   // used for array references
typedef unsigned int SFLAGS;  // short flag type

/* generic character types */
typedef unsigned char TEXT;   // base character type
typedef TEXT *STRING;         // string data type
typedef char SIGNCHAR;        // used to match up with signed prototypes

/* other generic typedefs */
typedef void VOID;          // these are for completeness
typedef size_t SIZE_T;      // ditto

/* storage classes can't be typedefed so let's cheat */
#define CALL (void)
#define EXTERN extern
#define INLINE inline
#define STATIC static
#define STRUCT struct
#define INTERRUPT interrupt

/* program name and version information */
#define PROG_NAME (STRING) "Flicker Free Mouse Motion"
#define PROG_CRHT (STRING) "(C) 1994 Ahpah Software Inc."
#define PROG_VER  (STRING) "1.01"
#define PROG_VNUM (WORD)   101


