// udpctl.cpp : Implementation of the CUdpCtrl OLE control class.

#include "stdafx.h"
#include "udp.h"
#include "udpctl.h"
#include "udpppg.h"
#include <limits.h>

#define ERR_None				0L
#define HOST_NAME_LEN			50
#define WM_USER_ASYNC_SELECT	(WM_USER+201)

#define MAKEWORD(a, b)      	((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))

WSADATA 				wsaData;
WORD					VersionRequested=MAKEWORD(1,1);
unsigned int			MaxUDPBufferSize;
char					hostAddress[16];
int const				MODE_DESIGN=0;

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CUdpCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CUdpCtrl, COleControl)
	//{{AFX_MSG_MAP(CUdpCtrl)
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
	ON_MESSAGE(WM_USER_ASYNC_SELECT,OnAsyncSelect)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CUdpCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CUdpCtrl)
	DISP_PROPERTY(CUdpCtrl, "MyPort", m_myPort, VT_I2)
	DISP_PROPERTY(CUdpCtrl, "ToAddress", m_toAddress, VT_BSTR)
	DISP_PROPERTY(CUdpCtrl, "ToData", m_toData, VT_BSTR)
	DISP_PROPERTY(CUdpCtrl, "ToPort", m_toPort, VT_I2)
	DISP_PROPERTY_EX(CUdpCtrl, "Connected", GetConnected, SetConnected, VT_BOOL)
	DISP_PROPERTY_EX(CUdpCtrl, "DisConnected", GetDisConnected, SetDisConnected, VT_BOOL)
	DISP_PROPERTY_EX(CUdpCtrl, "ErrorCode", GetErrorCode, SetErrorCode, VT_I2)
	DISP_PROPERTY_EX(CUdpCtrl, "MaxBufferSize", GetMaxBufferSize, SetMaxBufferSize, VT_I4)
	DISP_PROPERTY_EX(CUdpCtrl, "MyAddress", GetMyAddress, SetMyAddress, VT_BSTR)
	DISP_PROPERTY_EX(CUdpCtrl, "Send", GetSend, SetSend, VT_BOOL)
	DISP_DEFVALUE(CUdpCtrl, "Send")
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CUdpCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CUdpCtrl, COleControl)
	//{{AFX_EVENT_MAP(CUdpCtrl)
	EVENT_CUSTOM("DataIn", FireDataIn, VTS_BSTR  VTS_I2  VTS_BSTR)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CUdpCtrl, 1)
	PROPPAGEID(CUdpPropPage::guid)
END_PROPPAGEIDS(CUdpCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CUdpCtrl, "UDP.UdpCtrl.1",
	0xfbf0ff60, 0x90a2, 0x11ce, 0xbb, 0x3d, 0x0, 0x60, 0x8c, 0x60, 0xe9, 0x8a)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CUdpCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DUdp =
		{ 0xfbf0ff61, 0x90a2, 0x11ce, { 0xbb, 0x3d, 0x0, 0x60, 0x8c, 0x60, 0xe9, 0x8a } };
const IID BASED_CODE IID_DUdpEvents =
		{ 0xfbf0ff62, 0x90a2, 0x11ce, { 0xbb, 0x3d, 0x0, 0x60, 0x8c, 0x60, 0xe9, 0x8a } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwUdpOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CUdpCtrl, IDS_UDP, _dwUdpOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CUdpCtrl::CUdpCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CUdpCtrl

BOOL CUdpCtrl::CUdpCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_UDP,
			IDB_UDP,
			FALSE,                      //  Not insertable
			_dwUdpOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CUdpCtrl::CUdpCtrl - Constructor

CUdpCtrl::CUdpCtrl()
{
    char		hostName[HOST_NAME_LEN];
    PHOSTENT	phostent;
    IN_ADDR		in;

	InitializeIIDs(&IID_DUdp, &IID_DUdpEvents);

	SetInitialSize(28,28);

	if (WSAStartup(VersionRequested,&wsaData)!=0) return; 
	//check the WinSock info
	if ((LOBYTE(wsaData.wVersion)!=LOBYTE(VersionRequested))||
		(HIBYTE(wsaData.wVersion)!=HIBYTE(VersionRequested)))
		return;
	gethostname(hostName,HOST_NAME_LEN);
	phostent=gethostbyname(hostName);
	memcpy(&in,phostent->h_addr,4);
	memcpy(hostAddress,inet_ntoa(in),16);
	MaxUDPBufferSize=(unsigned int)wsaData.iMaxUdpDg;
	if (MaxUDPBufferSize>INT_MAX)
		MaxUDPBufferSize=INT_MAX;
}


/////////////////////////////////////////////////////////////////////////////
// CUdpCtrl::~CUdpCtrl - Destructor

CUdpCtrl::~CUdpCtrl()
{
	//close any opened sockets
	if (m_scktAppsocket!=INVALID_SOCKET)
	{
		if (closesocket(m_scktAppsocket)==SOCKET_ERROR)
			m_iErrorCode=WSAGetLastError();
		m_scktAppsocket=INVALID_SOCKET;
	}   
	WSACleanup();
}


/////////////////////////////////////////////////////////////////////////////
// CUdpCtrl::OnDraw - Drawing function

void CUdpCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	CBitmap			bitmap;
	BITMAP			bmp;
	CPictureHolder	picHolder;
	CRect			rcSrcBounds;
	
	if (AmbientUserMode()==MODE_DESIGN)      
	{
		//load bitmap
		bitmap.LoadBitmap(IDB_UDP);
		bitmap.GetObject(sizeof(BITMAP),&bmp);
		rcSrcBounds.right=bmp.bmWidth;
		rcSrcBounds.bottom=bmp.bmHeight;
		//create picture and render
		picHolder.CreateFromBitmap(
			(HBITMAP)bitmap.m_hObject,NULL,FALSE);
		picHolder.Render(pdc,rcBounds,rcSrcBounds);
	}
	else
		ShowWindow(SW_HIDE);
}


/////////////////////////////////////////////////////////////////////////////
// CUdpCtrl::DoPropExchange - Persistence support

void CUdpCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	PX_String(pPX, _T("ToAddress"), m_toAddress);
	PX_String(pPX, _T("ToData"), m_toData);
	PX_Short(pPX, _T("ToPort"), m_toPort);
	PX_String(pPX, _T("MyAddress"), m_strMyAddress);
	PX_Short(pPX, _T("MyPort"), m_myPort);
	PX_Long(pPX, _T("MaxBufferSize"), m_lMaxBufferSize);
	PX_Short(pPX, _T("ErrorCode"), m_iErrorCode);
	PX_Bool(pPX, _T("Send"), m_bSend);
	PX_Bool(pPX, _T("Disconnected"), m_bDisconnected);
	PX_Bool(pPX, _T("Connected"), m_bConnected);
}


/////////////////////////////////////////////////////////////////////////////
// CUdpCtrl::OnResetState - Reset control to default state

void CUdpCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	m_toAddress = "";
	m_toData = "";
	m_toPort = 0;
	m_strMyAddress = (LPSTR)hostAddress;
	m_myPort = 0;
	m_lMaxBufferSize = (long)MaxUDPBufferSize;
	m_iErrorCode = 0;
	m_bSend = FALSE;
	m_bDisconnected = TRUE;
	m_bConnected = FALSE;
	m_scktAppsocket = INVALID_SOCKET;
}

/////////////////////////////////////////////////////////////////////////////
// CUdpCtrl::AboutBox - Display an "About" box to the user

void CUdpCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_UDP);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CUdpCtrl message handlers

BOOL CUdpCtrl::GetConnected() 
{
	return m_bConnected;
}

void CUdpCtrl::SetConnected(BOOL bNewValue) 
{
	SOCKADDR_IN		addr;
   	int 			addrLen=sizeof(addr);
   	
	if (AmbientUserMode()==MODE_DESIGN)      
	{
		m_bConnected = FALSE;
		SetModifiedFlag();
	}
	else
	{
		m_bConnected = bNewValue;
		SetModifiedFlag();
		if (bNewValue)
		{
			addr.sin_family=AF_INET;
			addr.sin_port=htons(m_myPort);
			addr.sin_addr.s_addr=htonl(INADDR_ANY);				
		    //connect the socket
			m_scktAppsocket=socket(AF_INET,SOCK_DGRAM,0);			    
			if (m_scktAppsocket==INVALID_SOCKET)
				m_iErrorCode=WSAGetLastError();				
			else
			{
				if (bind(m_scktAppsocket,
					(LPSOCKADDR)&addr,sizeof(addr))==SOCKET_ERROR)
					m_iErrorCode=WSAGetLastError();
				else
				{
					//find out the port number that may have been
					//automatically assigned
					getsockname(m_scktAppsocket,(LPSOCKADDR)&addr,&addrLen);
					m_myPort=ntohs(addr.sin_port);						
					if (WSAAsyncSelect(m_scktAppsocket,
						m_hWnd,WM_USER_ASYNC_SELECT,FD_READ|FD_WRITE)==SOCKET_ERROR)
						m_iErrorCode=WSAGetLastError();
				}
			    //set disconnected to false
			    SetDisConnected(FALSE);
		   	}
	    }
    }
}

BOOL CUdpCtrl::GetDisConnected() 
{
	return m_bDisconnected;
}

void CUdpCtrl::SetDisConnected(BOOL bNewValue) 
{
	if (AmbientUserMode()==MODE_DESIGN)      
	{
		m_bDisconnected=TRUE;
		SetModifiedFlag();
	}
	else
	{
		m_bDisconnected = bNewValue;
		SetModifiedFlag();
		if (bNewValue)
		{
			//close any opened sockets
			if (m_scktAppsocket!=INVALID_SOCKET)
			{
				if (closesocket(m_scktAppsocket)==SOCKET_ERROR)
					m_iErrorCode=WSAGetLastError();
				m_scktAppsocket=INVALID_SOCKET;
			}   
		    //set connected to false
		    SetConnected(FALSE);
	    }           
	}
}

short CUdpCtrl::GetErrorCode() 
{
	return m_iErrorCode;
}

void CUdpCtrl::SetErrorCode(short nNewValue) 
{
	m_iErrorCode=nNewValue;
	SetModifiedFlag();
}

long CUdpCtrl::GetMaxBufferSize() 
{
	return m_lMaxBufferSize;
}

void CUdpCtrl::SetMaxBufferSize(long nNewValue) 
{
	//read-only
}

BSTR CUdpCtrl::GetMyAddress() 
{
	return m_strMyAddress.AllocSysString();
}

void CUdpCtrl::SetMyAddress(LPCTSTR lpszNewValue) 
{
	//read-only
}

BOOL CUdpCtrl::GetSend() 
{
	return m_bSend;
}

void CUdpCtrl::SetSend(BOOL bNewValue) 
{
	if (AmbientUserMode()==MODE_DESIGN)      
	{
		m_bSend = FALSE;
		SetModifiedFlag();
	}
	else
	{
	    m_bSend=bNewValue;
	    PostMessage(WM_USER_ASYNC_SELECT,m_scktAppsocket,
	    	WSAMAKESELECTREPLY(FD_WRITE,0));
	}
}

LONG CUdpCtrl::OnAsyncSelect(WPARAM wParam,LPARAM lParam)
{
   	SOCKADDR_IN		addr;
   	int 			addrLen=sizeof(addr);
    char 			*tempIn,*fromAddrPtr;
   	unsigned int	stringLen;
   	short 			fromPort;
   	unsigned int	nBytesSent,nBytesRecv;
   	IN_ADDR			inFrom;
    char			fromAddr[16];

	if (WSAGETSELECTERROR(lParam)!=0)
		return ERR_None;
	switch(WSAGETSELECTEVENT(lParam))
	{
		case FD_READ:
			if (!m_bSend)
			{
			 	tempIn=(char *)calloc(MaxUDPBufferSize,sizeof(char));
				nBytesRecv=recvfrom(m_scktAppsocket,
					tempIn,MaxUDPBufferSize,0,(LPSOCKADDR)&addr,&addrLen);
				if (nBytesRecv==SOCKET_ERROR)
	        		m_iErrorCode=WSAGetLastError();
	        	else
	        	{
					//get the from address
					memcpy(&inFrom,&addr.sin_addr.s_addr,4);
					memcpy(fromAddr,inet_ntoa(inFrom),16);
					fromPort=ntohs(addr.sin_port);
					fromAddrPtr=fromAddr;
					FireDataIn(fromAddrPtr,fromPort,tempIn);
				}            
				if (tempIn)
					free(tempIn);
			}
			break;
		case FD_WRITE:
			//is there any data to send
	    	if (m_bSend)
	    	{
	        	//get the destination information
	        	addr.sin_family=AF_INET;
	        	addr.sin_port=htons(m_toPort);
	        	addr.sin_addr.s_addr=inet_addr(m_toAddress);
	        	if (!m_toData.IsEmpty())
	        	{                                     
	        		stringLen=m_toData.GetLength();
	        		nBytesSent=sendto(m_scktAppsocket,
	        			m_toData,stringLen,0,(LPSOCKADDR)&addr,sizeof(addr));	
	        		if (nBytesSent==SOCKET_ERROR)
	        			m_iErrorCode=WSAGetLastError();
	        	}   
	        	//reset the send flag
	        	SetSend(FALSE);
				SetModifiedFlag();
	    	}
			break;
		default:
			break;
	}
	return ERR_None;
}
