#include <winsock.h>

// udpctl.h : Declaration of the CUdpCtrl OLE control class.

/////////////////////////////////////////////////////////////////////////////
// CUdpCtrl : See udpctl.cpp for implementation.

class CUdpCtrl : public COleControl
{
	DECLARE_DYNCREATE(CUdpCtrl)

// Constructor
public:
	CUdpCtrl();

// Overrides

	// Drawing function
	virtual void OnDraw(
				CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);

	// Persistence
	virtual void DoPropExchange(CPropExchange* pPX);

	// Reset control state
	virtual void OnResetState();

// Implementation
protected:
	~CUdpCtrl();

	// Storage for Get/Set properties
	CString 	m_strMyAddress;		//read-only
	long 		m_lMaxBufferSize;	//read-only
	short 		m_iErrorCode;
	BOOL 		m_bSend;
	BOOL 		m_bConnected;		//read-only @ Design-Time
	BOOL 		m_bDisconnected;	//read-only @ Design-Time
	SOCKET 		m_scktAppsocket;

	DECLARE_OLECREATE_EX(CUdpCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CUdpCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CUdpCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CUdpCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CUdpCtrl)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CUdpCtrl)
	short m_myPort;
	CString m_toAddress;
	CString m_toData;
	short m_toPort;
	afx_msg BOOL GetConnected();
	afx_msg void SetConnected(BOOL bNewValue);
	afx_msg BOOL GetDisConnected();
	afx_msg void SetDisConnected(BOOL bNewValue);
	afx_msg short GetErrorCode();
	afx_msg void SetErrorCode(short nNewValue);
	afx_msg long GetMaxBufferSize();
	afx_msg void SetMaxBufferSize(long nNewValue);
	afx_msg BSTR GetMyAddress();
	afx_msg void SetMyAddress(LPCTSTR lpszNewValue);
	afx_msg BOOL GetSend();
	afx_msg void SetSend(BOOL bNewValue);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();
	afx_msg LONG OnAsyncSelect(WPARAM wParam, LPARAM lParam);

// Event maps
	//{{AFX_EVENT(CUdpCtrl)
	void FireDataIn(LPCTSTR FromAddress, short FromPort, LPCTSTR FromData)
		{FireEvent(eventidDataIn,EVENT_PARAM(VTS_BSTR  VTS_I2  VTS_BSTR), FromAddress, FromPort, FromData);}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CUdpCtrl)
	dispidConnected = 5L,
	dispidDisConnected = 6L,
	dispidErrorCode = 7L,
	dispidMaxBufferSize = 8L,
	dispidMyAddress = 9L,
	dispidSend = 10L,
	dispidMyPort = 1L,
	dispidToAddress = 2L,
	dispidToData = 3L,
	dispidToPort = 4L,
	eventidDataIn = 1L,
	//}}AFX_DISP_ID
	};
};
